//
//  ViewController.swift
//  AmpGoogleAnalyticsSample
//
//  Created by Lopez Valenciano, Miguel on 9/8/16.
//  Copyright © 2016 Akamai. All rights reserved.
//

import UIKit
import AmpCore
import AmpGoogleAnalytics

class ViewController: UIViewController {
    
    @IBOutlet weak var playerView: UIView!
    
    var ampPlayer: AmpPlayer!
    var ampGA: AmpGoogleAnalytics!
    
    let url = "http://multiplatform-f.akamaihd.net/i/multi/april11/hdworld/hdworld_,768x432_1000_b,.mp4.csmil/master.m3u8"
    
    override func viewDidLoad() {
        super.viewDidLoad()
        
        self.createPlayer()
        
        // STEP 3: Attach an AmpPlayer and AmpEventIndexer to the AmpGA module
        self.ampGA = AmpGoogleAnalytics.sharedInstance
        self.ampGA.attach(self.ampPlayer!)
    }
    
    func createPlayer() {
        if self.ampPlayer == nil {
            
            // Instantiate player
            let rect = CGRect(x: 10, y: 40, width: 300, height: 240)
            
            self.ampPlayer = AmpPlayer(parentView: self.view)
            self.ampPlayer.autoplay = true
            self.ampPlayer.setLicense("AwEojcHro2SUbga06551M7nl++cKIHHciAplDLP1rDiatu8Q1qOgvxSpZEenatDlNzlTf8trT9Te/+3zD+tKLCEjOiGlAVWzLhjvbii8NWYoCl35kC/vmaQ2DAn+FiK4udWyFgu7KS/FrnLdgCO2r60i8SPAAt+E6aFt4ziU9CheNi20mEeJNroHtOkj+WY7wlGrN9xGeqFwt3pun6RHqa2ZKZ3BLf9Lm1dr0rqrm3tPm6hUiDg2uRwQhvy6jnFUM1w=")
            
            print("AKAMAI PLAYER VERSION: \(self.ampPlayer!.version)")
            
            // We can now use the ampPlayer directly, instead of accessing it from the manager
            self.ampPlayer?.registerObserver(self)
            
            print("VERSION: \(self.ampPlayer.version)")
            
            self.ampPlayer?.handleUrl(url)
        }
    }
    
    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }
    
}

extension ViewController : PlayerEventObserver {
    
    func onBufferingStateChanged(_ ampPlayer: AmpPlayer) {
        if (ampPlayer.bufferingState == BufferingState.ready) {
            print("BufferingState.Ready")
            ampPlayer.play()
        }
    }
    
    func onDoubleTap(_ ampPlayer: AmpPlayer) {
        if (ampPlayer.playbackState == .playing) {
            ampPlayer.pause()
        } else {
            ampPlayer.play()
        }
    }
}
